import numpy
from mpi4py import MPI

from matrix import Matrix


class MatrixMPI:
    __comm__ = MPI.COMM_WORLD
    __size__ = __comm__.Get_size()
    __rank__ = __comm__.Get_rank()

    __matrix__: Matrix = None
    __chunk__: list = None

    def __init__(self, data=None, shape=None, structure=None, model=None, offset=None, n=None):
        self.__matrix__ = Matrix(data=data, shape=shape, structure=structure, model=model, offset=offset, n=n)

        total_amount_of_rows = self.__matrix__.shape()[0]
        chunks = numpy.array_split(list(range(total_amount_of_rows)), self.__size__)
        self.__chunk__ = chunks[self.__rank__].tolist()

    def __str__(self):
        return str(self.__matrix__)

    def get_rank_data(self):
        rows = len(self.__chunk__)
        cols = self.__matrix__.shape()[1]
        return Matrix(self.__matrix__[self.__chunk__], (rows, cols))

    def transpose(self):
        return self.__matrix__.transpose()

    def T(self):
        return self.transpose()


mpi_matrix = MatrixMPI(list(range(1, 25)), (12, 2))
print(mpi_matrix.transpose())
